//CGO_ENABLED=0 GOOS=linux go build -v -a -tags netgo -ldflags '-w' -o mailsyncer *.go

package main

import (
	"fmt"
	"log"
	"os"
	"os/signal"
	"syscall"
	"time"

	dovecot "git.ververis.eu/mandi/modDovecot"
	logrus "github.com/sirupsen/logrus"
)

func main() {
	fmt.Println("Hallo welt!")

	f, err := os.OpenFile("testlogrus.log", os.O_APPEND|os.O_CREATE|os.O_RDWR, 0666)
	if err != nil {
		fmt.Printf("error opening file: %v", err)
	}

	logger := logrus.New()
	logger.SetOutput(f)

	log := log.Default()

	ds := dovecot.MailServer{
		ApiConfig: &dovecot.ApiConfig{
			ApiHost:  "https://plesk.ververis.eu",
			ApiUser:  "admin",
			Password: "Sektor@mailD2312",
		},
		SSHConfig: &dovecot.SSHConfig{
			SSHHost:             "89.22.111.212",
			SSHPort:             "22",
			SSHUser:             "root",
			LocalPrivateKeyPath: "/Users/mandi/.ssh/id_rsa",
			LocalKnownHostPath:  "/Users/mandi/.ssh/known_hosts",
		},
		MaildirPath:        "/var/qmail/mailnames/ververis.eu",
		BakupMailsPath:     "sync",
		BackupAccountsPath: "sync/accounts",
		MailDirOwner:       "popuser",
		MailDirGroup:       "popuser",
	}

	dv := ds.NewServer()

	/*
		p2 := dovecot.FullPacket{}

		a := &types.Action{}
		a.Filter = types.Filter{
			SiteID: 1,
		}

		a.Filter.MailName = types.MailName{
			Name:     "test",
			Mailbox:  &types.MailBox{Enabled: true},
			Password: &types.Password{Value: "Test@fullF1223", Type: string(dovecot.Plain)},
			Antivir:  &types.Antivir{Antivir: string(dovecot.Inout)},
		}
		a.XMLName.Local = string(dovecot.Create)
		pfull := types.Packet{
			Mail: types.Mail{
				Action: a,
			},
		}

		p2.Packets = append(p2.Packets, &pfull)
	*/

	p := dovecot.PacketValues{}
	p.AddPacket(1, dovecot.Create, "test", "Test@mail_123", true, dovecot.Plain, dovecot.Inout)
	p3 := dovecot.PacketValues{}
	p3.AddPacket(1, dovecot.Create, "pack2", "pack2@mail_667676", true, dovecot.Plain, dovecot.Inout)

	/*
		pf := dovecot.FilePacket{
			FilePath: "sync/accounts/new.json",
		}
		//ps := []dovecot.IPacket{pf}

		dv.RestoreAccounts(pf)
	*/

	/*
		_, err := dv.SynchroniseMail(true)
		if err != nil {
			fmt.Println(err)
		}
		_, err = dv.BackupAccounts()
		if err != nil {
			fmt.Println(err)
		}
	*/

	termChan := make(chan os.Signal)
	signal.Notify(termChan, syscall.SIGTERM, syscall.SIGINT)
	go func() {
		<-termChan
		log.Print("\nSIGTERM received. Shutdown process initiated\n")
		os.Exit(0)

	}()

	/*
	 */
	err = dv.TestSSH()
	if err != nil {
		fmt.Println("Test SSH: ", err)
	}

	go func() {
		for {
			fmt.Println("Start syncronisation...")
			_, err := dv.SynchroniseMail(true)
			if err != nil {
				fmt.Println("Synch Error: ", err)
			}
			_, err = dv.BackupAccounts()
			if err != nil {
				fmt.Println("Account Error: ", err)
			}

			countdown(120 * time.Second)
		}
	}()
	select {}
	//dv.RestoreMail()
}

func countdown(duration time.Duration) {
	for i := int(duration.Seconds()); i >= 0; i-- {
		time.Sleep(time.Second)
		fmt.Printf("\rNext sync in %d seconds", i)
	}
	fmt.Println()
}
