package types

import "encoding/xml"

type Packet struct {
	XMLName xml.Name `xml:"packet"`
	Mail    Mail     `xml:"mail"`
}

type Action struct {
	XMLName xml.Name
	Filter  Filter  `xml:",innerxml"`
	Result  *Result `xml:"result,omitempty"`
}

type Filter struct {
	XMLName  xml.Name `xml:"filter"`
	SiteID   int      `xml:"site-id"`
	MailName MailName
}
type Mail struct {
	Action *Action `xml:",any"`
}
type MailName struct {
	XMLName  xml.Name  `xml:"mailname,omitempty"`
	Id       int       `xml:"id,omitempty"`
	Name     string    `xml:"name,omitempty"`
	Mailbox  *MailBox  `xml:",omitempty"`
	Password *Password `xml:",omitempty"`
	Antivir  *Antivir  `xml:",omitempty"`
}

type MailBox struct {
	XMLName xml.Name `xml:"mailbox"`
	Enabled bool     `xml:"enabled,omitempty"`
}
type Antivir struct {
	XMLName xml.Name `xml:"antivir"`
	Antivir string   `xml:",innerxml"`
}
type Password struct {
	XMLName xml.Name `xml:"password,omitempty"`
	Value   string   `xml:"value,omitempty"`
	Type    string   `xml:"type,omitempty"`
}

type Result struct {
	Status    string    `xml:"status,omitempty"`
	ErrorCode string    `xml:"errcode,omitempty"`
	ErrorText string    `xml:"errtext,omitempty"`
	MailName  *MailName `xml:",omitempty"`
}
